算法每日一题: 最大合金数 | 二分

大家好,我是星恒,今天给大家带来的是一道比较正常的二分题目

题目:leetcode 2861

假设你是一家合金制造公司的老板,你的公司使用多种金属来制造合金。现在共有 n 种不同类型的金属可以使用,并且你可以使用 k 台机器来制造合金。每台机器都需要特定数量的每种金属来创建合金。

对于第 i 台机器而言,创建合金需要 compositionij 份 j 类型金属。最初,你拥有 stocki 份 i 类型金属,而每购入一份 i 类型金属需要花费 costi 的金钱。

给你整数 n、k、budget,下标从 1 开始的二维数组 composition,两个下标从 1 开始的数组 stock 和 cost,请你在预算不超过 budget 金钱的前提下,最大化 公司制造合金的数量。
所有合金都需要由同一台机器制造。

返回公司可以制造的最大合金数。

示例:
示例 1:

复制代码
输入:n = 3, k = 2, budget = 15, composition = [[1,1,1],[1,1,10]], stock = [0,0,0], cost = [1,2,3]
输出:2
解释:最优的方法是使用第 1 台机器来制造合金。
要想制造 2 份合金,我们需要购买:
- 2 份第 1 类金属。
- 2 份第 2 类金属。
- 2 份第 3 类金属。
总共需要 2 * 1 + 2 * 2 + 2 * 3 = 12 的金钱,小于等于预算 15 。
注意,我们最开始时候没有任何一类金属,所以必须买齐所有需要的金属。
可以证明在示例条件下最多可以制造 2 份合金。

示例 2:

复制代码
输入:n = 3, k = 2, budget = 15, composition = [[1,1,1],[1,1,10]], stock = [0,0,100], cost = [1,2,3]
输出:5
解释:最优的方法是使用第 2 台机器来制造合金。 
要想制造 5 份合金,我们需要购买: 
- 5 份第 1 类金属。
- 5 份第 2 类金属。 
- 0 份第 3 类金属。 
总共需要 5 * 1 + 5 * 2 + 0 * 3 = 15 的金钱,小于等于预算 15 。 
可以证明在示例条件下最多可以制造 5 份合金。

示例 3:

复制代码
输入:n = 2, k = 3, budget = 10, composition = [[2,1],[1,2],[1,1]], stock = [1,1], cost = [5,5]
输出:2
解释:最优的方法是使用第 3 台机器来制造合金。
要想制造 2 份合金,我们需要购买:
- 1 份第 1 类金属。
- 1 份第 2 类金属。
总共需要 1 * 5 + 1 * 5 = 10 的金钱,小于等于预算 10 。
可以证明在示例条件下最多可以制造 2 份合金。

提示:

  • 1 <= n, k <= 100
  • 0 <= budget <= 108
  • composition.length == k
  • compositioni.length == n
  • 1 <= compositionij <= 100
  • stock.length == cost.length == n
  • 0 <= stocki <= 108
  • 1 <= costi <= 100

分析:

这道题的思路是二分。因为制造数的范围是有限的,是10^8, 所以我们可以遍历可以制造数量的最大数,利用二分来优化:遍历使用的机器,当使用这个数量制造金属时,是否会超过预算。这样,我们就可以遍历到需要的金属最大数。

这确实是很优质的解法,我们来看看我们的暴力求解。

乍一看,这道题是让我们选择对机器,然后计算能制造的金属数。对于确定使用的机器,我们并没有什么好方法,我们只能通过遍历比较哪台机器在budget下的制造的数量最多,来侧面反应出哪个机器最多(这也是计算机的擅长的事)。

我们来分析一下他的时间复杂度:遍历每一种机器为n,遍历最大金数数(budget/cost),计算一份合金所需花费k。总的时间复杂度O(n * (k + budget/cost))

题解:

java 复制代码
class Solution {
    public int maxNumberOfAlloys(int n, int k, int budget, List<List<Integer>> composition, List<Integer> stock, List<Integer> cost) {
        int left = 1, right = 200000000, ans = 0;
        while (left <= right) {
            int mid = (left + right) / 2;
            boolean valid = false;
            for (int i = 0; i < k; ++i) {
                long spend = 0;
                for (int j = 0; j < n; ++j) {
                    spend += Math.max((long) composition.get(i).get(j) * mid - stock.get(j), 0) * cost.get(j);
                }
                if (spend <= budget) {
                    valid = true;
                    break;
                }
            }
            if (valid) {
                ans = mid;
                left = mid + 1;
            } else {
                right = mid - 1;
            }
        }
        return ans;
    }
}

时间复杂度:O(nklogC)

如果大家有什么思考和问题,可以在评论区讨论,也可以私信我,很乐意为大家效劳。

好啦,今天的每日一题到这里就结束了,如果大家觉得有用,可以可以给我一个小小的赞呢,我们下期再见!

相关推荐
小O的算法实验室13 分钟前
IEEE TEVC,基于精确与DQN群智能调度方法用于多目标异构USV
算法
可乐ea1 小时前
AI Agent 工具调用准确性评测:选择错误与参数错误分开测
大数据·人工智能·算法·大模型·工具调用·ai智能体·agent评测
上位机妹子1 小时前
C 语言 数组删除指定元素(快慢指针法)
c语言·数据结构·算法
心中有你02141 小时前
【路径规划】A*寻路算法最通俗易懂讲解(C语言完整实现+详细注释)
c语言·开发语言·算法
papaofdoudou2 小时前
初中数学-整数整除判定法全解:从 2 到 19 的方法、依据与证明
算法
让学习成为一种生活方式2 小时前
啤酒花基因组与重测序--Nature Communications
人工智能·算法
l1t3 小时前
DeepSeek总结的OpenZL压缩变换器
c++·算法
想吃火锅10053 小时前
【leetcode】238.除了自身以外数组的乘积js
javascript·算法·leetcode
坤坤子吖3 小时前
算法学习——高精度加减乘除
c++·笔记·学习·算法
CQU_JIAKE3 小时前
10.1[A]2267,磐久UMX【上下文128K,KVCache部分]
算法